Bug 1210004

Summary: Review Request: libkindrv - Driver for controlling robotic arms by Kinova
Product: [Fedora] Fedora Reporter: Till Hofmann <thofmann>
Component: Package ReviewAssignee: gil cattaneo <puntogil>
Status: CLOSED ERRATA QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: medium    
Version: rawhideCC: hobbes1069, kbon, package-review, puntogil
Target Milestone: ---Flags: puntogil: fedora-review+
gwync: fedora-cvs+
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard:
Fixed In Version: libkindrv-0.1.2-1.fc20 Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2015-04-26 12:45:12 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:

Description Till Hofmann 2015-04-08 16:16:51 UTC
Spec URL: https://thofmann.fedorapeople.org/libkindrv.spec
SRPM URL: https://thofmann.fedorapeople.org/libkindrv-0.1.2-1.fc20.src.rpm
printf patch: https://thofmann.fedorapeople.org/libkindrv.printf.patch

Description:
libkindrv is an open-source driver for robotic arms by Kinova [1]. The driver is developed independently but with support from Kinova. It is currently used by several robotics institutes.

The package currently contains one patch which will also be included upstream. As soon as a new version with the patch is released, I will remove the patch from the package.

rpmlint produces two warnings, which imho can be ignored:
1. libkindrv.x86_64: W: no-documentation
 libkindrv only consists of the library, all documentation is contained in the devel package.
2. libkindrv-devel.x86_64: W: only-non-binary-in-usr-lib
 Similar to most devel packages, libkindrv-devel contains a symlink to the actual library in /usr/lib{,64} and does not contain a binary file.


I would appreciate a review !


Fedora Account System Username: thofmann


[1] http://kinovarobotics.com/

Comment 1 gil cattaneo 2015-04-13 12:50:56 UTC
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- If (and only if) the source package includes the text of the license(s) in
  its own file, then that file, containing the text of the license(s) for the
  package is included in %doc.
  Note: Cannot find LICENSE.GPL in rpm(s)
  See:
  http://fedoraproject.org/wiki/Packaging/LicensingGuidelines#License_Text
 IGNORE

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
     Note: Using prebuilt packages
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 9 files have unknown license. Detailed output of
     licensecheck in /home/gil/1210004-libkindrv/review-
     libkindrv/licensecheck.txt
[?]: License file installed when any subpackage combination is installed.
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/share/licenses
[?]: Package must own all directories that it creates.
     Note: Directories without known owners: /etc/udev, /usr/share/licenses,
     /etc/udev/rules.d
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
     Note: Using prebuilt rpms.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 798720 bytes in 161 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Reviewer should test that the package builds in mock.
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: Scriptlets must be sane, if used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[?]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see attached
     diff).
     See: (this test has no URL)
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: libkindrv-0.1.2-1.fc23.i686.rpm
          libkindrv-devel-0.1.2-1.fc23.i686.rpm
          libkindrv-0.1.2-1.fc23.src.rpm
libkindrv.i686: W: no-documentation
3 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
INFO: mock.py version 1.2.7 starting (python version = 2.7.5)...
Start: init plugins
INFO: selinux enabled
Finish: init plugins
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled yum cache
Start: cleaning yum metadata
Finish: cleaning yum metadata
INFO: enabled ccache
Mock Version: 1.2.7
INFO: Mock Version: 1.2.7
Finish: chroot init
INFO: installing package(s): rpmlint
ERROR: Command failed. See logs for output.
 # /usr/bin/dnf --installroot /var/lib/mock/fedora-rawhide-i386/root/ --releasever 23 install rpmlint --setopt=tsflags=nocontexts



Diff spec file in url and in SRPM
---------------------------------
--- /home/gil/1210004-libkindrv/libkindrv.spec	2015-04-13 14:18:09.000000000 +0200
+++ /home/gil/1210004-libkindrv/review-libkindrv/srpm-unpacked/libkindrv.spec	2015-04-08 17:16:10.000000000 +0200
@@ -5,5 +5,5 @@
 
 License:    LGPLv3+
-URL:        http://fawkesrobotics.org/projects/libkindrv/
+URL:        http://www.fawkesrobotics.org
 
 
@@ -11,5 +11,4 @@
 %global shortcommit %(c=%{commit}; echo ${c:0:7})
 Source0:    http://git.fawkesrobotics.org/libkindrv.git/snapshot/%{commit}.tar.gz#/%{name}-%{shortcommit}.tar.gz
-# merged in upstream master, will be removed once a new version has been tagged
 Patch0: libkindrv.printf.patch
 
@@ -37,5 +36,4 @@
 pushd build
 # we build the doc separately because we only want it in libkindrv-devel
-# and 'make install' would install it in the wrong directory
 %cmake \
   -DBUILD_DOC=OFF \
@@ -44,5 +42,5 @@
 make %{?_smp_mflags}
 
-make %{?_smp_mflags} apidoc
+make apidoc
 
 


Requires
--------
libkindrv-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    libkindrv(x86-32)

libkindrv (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    config(libkindrv)
    libboost_system.so.1.57.0
    libc.so.6
    libgcc_s.so.1
    libgcc_s.so.1(GCC_3.0)
    libm.so.6
    libstdc++.so.6
    libstdc++.so.6(CXXABI_1.3)
    libusb-1.0.so.0
    rtld(GNU_HASH)



Provides
--------
libkindrv-devel:
    libkindrv-devel
    libkindrv-devel(x86-32)
    pkgconfig(libkindrv)

libkindrv:
    config(libkindrv)
    libkindrv
    libkindrv(x86-32)
    libkindrv.so.0



Source checksums
----------------
http://git.fawkesrobotics.org/libkindrv.git/snapshot/f56752e15db2fa58e5748ce2f82e4a424d6c0337.tar.gz#/libkindrv-f56752e.tar.gz :
  CHECKSUM(SHA256) this package     : 74698984dea923840de5a1cf928f21b8b427aaf4b5c804cfa0b30965f839ad08
  CHECKSUM(SHA256) upstream package : 211f1bbf41ff271dd54becfc7e83e3c32f632373f71a07fa4b63ee51e28281c9
However, diff -r shows no differences


Generated by fedora-review 0.5.2 (63c24cb) last change: 2014-07-14
Command line :/usr/bin/fedora-review -vpn libkindrv -m fedora-rawhide-i386
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Comment 2 gil cattaneo 2015-04-13 12:53:01 UTC
NON blocking ISSUES:

Diff spec file in url and in SRPM
---------------------------------
--- /home/gil/1210004-libkindrv/libkindrv.spec	2015-04-13 14:18:09.000000000 +0200
+++ /home/gil/1210004-libkindrv/review-libkindrv/srpm-unpacked/libkindrv.spec	2015-04-08 17:16:10.000000000 +0200
@@ -5,5 +5,5 @@
 
 License:    LGPLv3+
-URL:        http://fawkesrobotics.org/projects/libkindrv/
+URL:        http://www.fawkesrobotics.org
 
 
@@ -11,5 +11,4 @@
 %global shortcommit %(c=%{commit}; echo ${c:0:7})
 Source0:    http://git.fawkesrobotics.org/libkindrv.git/snapshot/%{commit}.tar.gz#/%{name}-%{shortcommit}.tar.gz
-# merged in upstream master, will be removed once a new version has been tagged
 Patch0: libkindrv.printf.patch
 
@@ -37,5 +36,4 @@
 pushd build
 # we build the doc separately because we only want it in libkindrv-devel
-# and 'make install' would install it in the wrong directory
 %cmake \
   -DBUILD_DOC=OFF \
@@ -44,5 +42,5 @@
 make %{?_smp_mflags}
 
-make %{?_smp_mflags} apidoc
+make apidoc

Please, fix before import

Comment 3 Richard Shaw 2015-04-13 13:00:23 UTC
Looks like someone beat me to the punch but I'll add my comments anyway...

Drive by spec review:

Very clean overall!

You can ignore your #1 above, it looks like rpmlint hasn't been updated to understand %license.

This library (including the examples) seem to be LGPL licensed. Do you know why upstream has included LICENSE.GPL? I think you can drop it.

Comment 4 Bahram Maleki-Fard 2015-04-14 16:30:15 UTC
Thanks for the review request, and thanks for the reviews! I'm maintaining upstream :)

> This library (including the examples) seem to be LGPL licensed. Do you know
> why upstream has included LICENSE.GPL? I think you can drop it.

Because it is required to do so. Quote: "Please note that, since the LGPL is a set of additional permissions on top of the GPL, it's important to include both licenses so users have all the materials they need to understand their rights."
(https://www.gnu.org/licenses/gpl-howto.en.html)

Comment 5 Till Hofmann 2015-04-15 11:13:13 UTC
Thanks for reviewing and your additional remarks!

I didn't upload the new SRPM after my last SPEC file change, which mostly added comments - sorry for that.

Concerning the license: LGPLv2 seems to be a 'stand-alone' license, while LGPLv3 only adds permissions on top of GPL. So a LGPLv2 package only needs the LGPL license text included, while newer versions also need the GPL license text included. I hope this clears up some confusion.

Comment 6 Till Hofmann 2015-04-15 11:21:29 UTC
New Package SCM Request
=======================
Package Name: libkindrv
Short Description: Driver for controlling robotic arms by Kinova
Upstream URL: http://fawkesrobotics.org/projects/libkindrv/
Owners: thofmann
Branches: f20 f21 f22
InitialCC:

Comment 7 Gwyn Ciesla 2015-04-15 13:47:12 UTC
Git done (by process-git-requests).

Comment 8 Fedora Update System 2015-04-16 08:57:18 UTC
libkindrv-0.1.2-1.fc22 has been submitted as an update for Fedora 22.
https://admin.fedoraproject.org/updates/libkindrv-0.1.2-1.fc22

Comment 9 Fedora Update System 2015-04-16 09:05:41 UTC
libkindrv-0.1.2-1.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/libkindrv-0.1.2-1.fc21

Comment 10 Fedora Update System 2015-04-16 09:07:20 UTC
libkindrv-0.1.2-1.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/libkindrv-0.1.2-1.fc20

Comment 11 Fedora Update System 2015-04-18 09:57:11 UTC
libkindrv-0.1.2-1.fc20 has been pushed to the Fedora 20 testing repository.

Comment 12 Fedora Update System 2015-04-22 22:42:07 UTC
libkindrv-0.1.2-1.fc22 has been pushed to the Fedora 22 stable repository.

Comment 13 Fedora Update System 2015-04-26 12:45:12 UTC
libkindrv-0.1.2-1.fc20 has been pushed to the Fedora 20 stable repository.

Comment 14 Fedora Update System 2015-04-26 12:45:18 UTC
libkindrv-0.1.2-1.fc21 has been pushed to the Fedora 21 stable repository.